/*
 *
 *   Copyright (C) 2016 AVM GmbH <fritzbox_info@avm.de>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef _AVM_GIC_H_
#define _AVM_GIC_H_


#include <linux/irqchip/arm-gic.h>

#define OFFSET_ICDICTR GIC_DIST_CTR
#define OFFSET_ICDISER GIC_DIST_ENABLE_SET
#define OFFSET_ICDICER GIC_DIST_ENABLE_CLEAR
#define OFFSET_ICDISPR GIC_DIST_PENDING_SET
#define OFFSET_ICDICPR GIC_DIST_PENDING_CLEAR
#define OFFSET_ICDIPTR GIC_DIST_TARGET
#define OFFSET_ICDIPR  GIC_DIST_PRI
#define OFFSET_ICDICR  GIC_DIST_CONFIG
#define OFFSET_ICDISR  GIC_DIST_IGROUP
#define OFFSET_ICDICPR GIC_DIST_PENDING_CLEAR

#define OFFSET_ICCIAR  GIC_CPU_INTACK
#define OFFSET_ICCEOIR GIC_CPU_EOI
#define OFFSET_ICCHPIR GIC_CPU_HIGHPRI
#define OFFSET_ICCPMR  GIC_CPU_PRIMASK

#ifdef CONFIG_ARCH_QCOM
#define AVM_IRQ_WD 0x23
#define AVM_IRQ_WD_BITE 0x24
#define AVM_IRQ_SWD_BARK 0xD5
#else
#define AVM_IRQ_WD 0x30
#endif

/* AMY: IRQs 170-180 are unused. -- crashes if used!
 *      IRQs 217-226 are also unused. -- This works!
 *      IRQs 250-255 are connected to edma_int_vec[31..26] but internally not
 *                   used according to Charlie/qca.
 */
#define AVM_IRQ_MESSAGING_START   (226 + 32 - NR_CPUS)
#define AVM_IRQ_MONITOR_START   (AVM_IRQ_MESSAGING_START - NR_CPUS)

#endif // #ifndef _AVM_GIC_H_
