#ifndef _AR7WDT_H_
#define _AR7WDT_H_

#include <linux/version.h>
#include "avm_sammel.h"

/**
 */
int __init ar7wdt_init(void);
void ar7wdt_cleanup(void);

/**
 * wdtimer.c  (nur 2.4 kernel)
 */
#if KERNEL_VERSION(2, 6, 0) > LINUX_VERSION_CODE
/*--- #if !defined(UINT32) ---*/
#define UINT32      unsigned int
#define INT32       signed int
#include <asm-mips/avalanche/generic/hal_modules/wdtimer.h>
#undef UINT32
#undef INT32

void wdtimer_init(unsigned int base_addr, unsigned int vbus_clk_freq);
int wdtimer_set_period(unsigned int msec);
int wdtimer_ctrl(WDTIMER_CTRL_T wd_ctrl);
int wdtimer_kick(void);
int write_disable_reg(unsigned int disable_value);

#define ar7wdt_hw_deinit()        wdtimer_ctrl(WDTIMER_CTRL_DISABLE)
#define ar7wdt_hw_trigger()       wdtimer_kick()
#endif


#endif /*--- #ifndef _AR7WDT_H_ ---*/
